<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>            
            </tbody>
        </table>
    </div>
</body>
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        console.log('document ready');
        getAllUsers();
    });

    function loadUsersInTable(users) {
        //  id, firstname, lastname, country,subject, customerType, registerStatus
        var tableUserElement = $("#table-users")

        for (let bI=0; bI < users.length; bI++) {
            var bNewRow = $("<tr>").appendTo(tableUserElement);
                $("<td>", {
                    html: users[bI].id
                }).appendTo(bNewRow);
                $("<td>", {
                    html: users[bI].firstname
                }).appendTo(bNewRow);
                $("<td>", {
                    html: users[bI].lastname
                }).appendTo(bNewRow);
                $("<td>", {
                    html: users[bI].country
                }).appendTo(bNewRow);
                $("<td>", {
                    html: users[bI].subject
                }).appendTo(bNewRow);
                $("<td>", {
                    html: users[bI].customerType
                }).appendTo(bNewRow);
                $("<td>", {
                    html: users[bI].registerStatus
                }).appendTo(bNewRow);

                const actionCol= $("<td>");                     
              
                $("<button>", {
                    class: "btn btn-primary",
                    html: "Edit"
                }).appendTo(actionCol).on("click", () =>{                                                 
                    console.log(users[bI].id);
                });

                $("<button>", {
                    class: "btn btn-primary",
                    html: "Delete"
                }).appendTo(actionCol).on("click", () => {
                    console.log(users[bI].id);
                });

                actionCol.appendTo(bNewRow);
        }
    }

    // Mẫu gọi API cho bài 35.30
    function getAllUsers() {
        //base url
        const vBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
        // create a request
       $.ajax({
        url:  vBASE_URL,
        type: 'GET',
        dataType: 'json',
        success: function(res) {            
            loadUsersInTable(res);
        },
        error: function (ajaxContext) {
          console.log(ajaxContext);
            alert(ajaxContext.statusText);
        }
    }); 
    }

    

</script>

</html>
